USE comptoir

-- afficher les noms des clients et la ville - client
select ClientNom, 
	ClientVille
From T_Client

-- afficher les noms des clients et la ville - client
-- Je veux que ceux qui habitent  Madrid
select ClientNom, 
	ClientVille
From T_Client 
Where ClientVille='Madrid'  -- filtre/condition

-- afficher les noms des clients et la ville - client
-- Je veux ceux qui n'habitent pas Madrid
select ClientNom, 
	ClientVille
From T_Client 
Where ClientVille <> 'Madrid'  

-- Je veux ceux qui n'habitent pas Madrid +
-- Ceux qui sont  leur compte : owner
select ClientNom, 
	-- ClientContactFonction -- seulement pour contrler
	ClientVille
From T_Client 
Where ClientVille <> 'Madrid' 
and ClientContactFonction='Owner'                         

-- Toujours une petite requte avant de faire la requte princ
-- visualiser la table (charge tout, les lignes, les colonnes)
select * From T_client

-- si grosse volumtrie de donnes - table importante +1MIllion
-- limiter le nombre de lignes
select TOP 10 * From T_client

-- je veux les noms des 10 premiers clients
-- * signifie toutes les colonnes donc si je veux afficher qu'une seule, il faut supprimer l'toile
select TOP 10 clientnom
From T_client

-- je veux afficher les pays des clients
select ClientPays
From T_client

-- je veux afficher les pays des clients
-- sans fonction, il affiche toute la table sans doublons
-- DISTINCT : afficher distinctement/sans doublons
select distinct ClientPays
From T_client

-- TRI ---- trier les clients par nom du client
Select *
From t_client
ORDER BY clientnom asc, ClientPays desc  -- trier, ordonner par
			-- 6me position

--- VIrgule
Select clientnom as nom,  
		clientpays
From T_Client

-- ALIAS DE COLONNE
-- 1 : nomcolonne pas parlant : retraduire/renommer
-- 2 : fonction intgres (rose) : sum(champ), year(champ)

Select cdedate as Datecommande -- un seul bloc - as pas obligatoire
From T_Commande

-- je souhaite afficher les annes de commande
Select distinct year(CdeDate) as 'Anne de commande'  --piocher l'anne dans la date de commande
From T_Commande

-- je souhaite compter le nombre de commandes
Select count(CdeNum) as 'Nombre de commandes'
From T_Commande

-- je souhaite compter le nombre de commandes 
-- par an -- PAR -- MOT MAGIQUE --> GROUP BY (exception tri)
select * from T_Commande

Select count(CdeNum) as 'Nombre de commandes',
		year(CdeDate) as 'anne de commande'
From T_Commande
			-- 1re tape : par : group by
			-- 2me tape : afficher les annes / copier/coller select
-- WHERE
GROUP BY year(CdeDate) -- anne et non par jour (cdedate)
-- order by -- alias
order by year(CdeDate) desc

-- sommer le poids
-- par transportvia, city
Select CommandeTransportVia, ShipCity,
		sum(CommandePoids) as 'Total poids'
From T_Commande
Group by CommandeTransportVia, ShipCity

-- Select, order, group by == ,
-- where, having == and / or

---------------------- WHERE ------------
------ IN     NOT IN ----------------------
Select *  From T_Commande

-- Brsil et Vnzuela
-- ce n'est pas COmmandetransportVia 2 et 3
Select *
From T_Commande
where ShipCountry In ('Venezuela','Brazil')  
	AND CommandeTransportVia NOT IN (2,3)
order by shipcountry desc

-- LIKE   NOT LIKE ---------------------
Select *
From T_Commande
where shipcountry like 'Vene%' -- % contient, commence, finit
				-- qu'importe ce qu'il y a aprs
				-- commence par

Select * -- se termine par
From T_Commande
where ShipAddress not like '%Carlos%' -- cherche carlos au milieu mais qui pourrait tre au dbut  la fin
-- on cherche le mot qu'importe ce qu'il y a avant et aprs

---------------------------------------------------------------------
-----------------CASE ------------------
-- Colonne conditionnelle : en fonction de valeurs dans une colonne, je cre une nouvelle colonne
-- si il y a telle valeur, alors ca sera a dans ma nouvelle colonne

USe ContosoRetailDW

Select distinct gender, -- crer une nouvelle colonne ,
	CASE
		-- quand dans la colonne gender c'est un M alors je veux la valeur Homme
		when gender='M' THEN 'Homme' -- quand
		when gender='F' THEN 'Femme' -- pour les autres, quand
		Else 'Non connu'                    -- pour les autres
	END as 'Genre'
From DimCustomer


-- critres sur deux champs diffrent + situation familiale
Select count(CustomerKey) as 'nombre de clients',
	CASE     -- et quand la sit fam est S, alors homme clibataire
		when gender='M' And MaritalStatus='S' THEN 'Homme clibataire' 
		-- gender M et mari
		when gender='M' And MaritalStatus='M' THEN 'Homme mari' 
		when gender='F' And MaritalStatus='M' THEN 'Femme mari' 
		when gender='F' And MaritalStatus='S' THEN 'Femme clibataire' 
		Else 'Non connu'                    
	END as 'Genre'
From DimCustomer
GROUP BY gender, MaritalStatus

------ GETDATE() ----------------------------
----------- Obtenir la date du jour sur le serveur !
select GETDATE()

------------------ DATEDIFF -- dlai, diffrence entre deux dates
select GETDATE(), BirthDate,
		DATEDIFF(year,birthdate, getdate() ) as 'ge'
from DImcustomer -- 1 unit de mesure (year, month, minute, etc.)
-- 2 date de dbut, 3 date de fin

----------------------------------------------
--
use comptoir

-- nombres de commandes par employe
-- seulement quand cmdtransportvia est gal 2 ou 3 : filtre BDD - where - avant de faire le calcul par quelque chose (count, somme, etc)
-- afficher seulement les id des employs qui ont ralis plus de 80 commandes
-- seulement aprs avoir calcul (aprs le group by), je peux faire un filtre sur rsultat intermdiaire / condition sur le group by/ count (fonction d'agrgation)
select count(cdenum) as 'nombre de commandes', EmployeID
from T_Commande
where CommandeTransportVia in (2,3) 
group by EmployeID
having count(cdenum) > 80
order by [nombre de commandes] desc

select * from T_Commande


----------------------- JOINTURES -----------------------------
use comptoir

-- savoir quels sont les clients qui ont command ?
-- quand la valeur (clientid) est dans les deux tables alors il ramne le rsultat
select distinct t_client.ClientID, clientnom
From t_client JOIN T_Commande
		ON t_client.ClientID = T_Commande.ClientId

-- savoir quels sont les clients qui ont command ? + date de commande
-- rcuprer des colonnes dans les tables slectionnes
select t_client.ClientID, clientnom,  CdeDate, CdeNum
From t_client JOIN T_Commande
		ON t_client.ClientID = T_Commande.ClientID

select count(ClientID) from T_Client

-- clients qui ont command ! je ne veux pas r-crire le nom de la table
-- trop long, dur  crire, visibilit ! alias de table : renommer la table

select distinct c.ClientID, clientnom
From t_client as c JOIN T_Commande as cm
		ON c.clientid=cm.ClientID

-- je veux tous mes clients et la correspondance avec table commande
select distinct t_client.ClientID, T_Commande.*
From t_client  LEFT JOIN   T_Commande  -- je veux tous les clients tb clt -gche
-- From T_Commande RIGHT JOIN   t_client  -- je veux tous les clients tb clt - drte
		ON t_client.ClientID = T_Commande.ClientId

-- seulement les clients qui n'ont pas command !
select distinct t_client.ClientID, T_Commande.*
From t_client  LEFT JOIN   T_Commande  
		ON t_client.ClientID = T_Commande.ClientId
		where T_Commande.ClientID is null
		-- quand le clientid dans la table commande n'existe pas !
		
		-- ou
		where CdeNum IS NULL -- on ne retrouve pas le client dans la table commande
							-- pas de correspondance : NULL
							-- Utiliser cl primaire ou cl trangre
							-- ATTENTION : champ qui ne contient pas de null